;*
;******************** DC,3  9 *************************************
;*
;*  ATtiny13A, RC- 9,6 
;*   - 37,5 
;*
;* Main:           
;* Delay:           
;* TimerOFF:       ,  
;* TIMER0_COMPA:    - 
;*
;* Fuses          CKSEL=10, SUT=10
;*                
;****************************************************************************

.nolist
.include "tn13def.inc"
.list

;*****  *****

.def	t1	 = r16     ;   
.def	CntSt = r17    ;     
.def	Cnt0 = r18     ;    0
.def	Cnt1 = r19     ;    1
.def	Cnt2 = r20     ;    2
.def	Cnt3 = r21     ;    3
.def	Comp = r22     ;              

;*****  *****

.equ  Const0 = 220   ;  0   					  
.equ  Const1 = 220   ;  1   
.equ  Const2 = 220   ;  2   
.equ  Const3 = 2     ;  3   
.equ  Imax = 245     ;    
.equ  Imin = 42;50      ;     

.cseg

.org 0
	rjmp Initial		 ;  

.org 1					 ;  
    reti

.org 6
	rjmp TIMER0_COMPA    ;  A / T0


Initial: ;  
	
    ldi   t1,(RamEnd)
    out   spl,t1	    ;  
	
   	ldi	t1,0b00001010  
	out	PORTB,t1        ; PB0- ,PB1- SB1
	ldi	t1,0b00001001	; PB3-   VT2	
	out	DDRB,t1		    ; PB4-   

clr Comp             ;    

ldi  t1,0            ;    T0
out  TCNT0,t1
ldi t1,(1<<COM0A1)|(1<<WGM01)|(1<<WGM00) ;   T0," "
out TCCR0A,t1
ldi t1,(1<<CS00)     ;     CK = 9,6 MHz
out TCCR0B,t1
ldi  t1,(1<<OCIE0A)
out  TIMSK0,t1       ;     T0

ldi t1,1<<ACBG
out ACSR,t1		;      AIN0 , 1,11V
ldi t1,(1<<MUX1)
out ADMUX,t1		 ;    , ADC2
ldi t1,1<<ACME
out ADCSRB,t1		 ;      AIN1 

ldi  CntSt,5        ;    
out  OCR0A,CntSt

ldi Cnt0,Const0     ;    
ldi Cnt1,Const1     ; T.=0,0000266*(Const0*Const1*Const2*Const3)
ldi Cnt2,Const2
ldi Cnt3,Const3
sei                 ;  

Main:  ;  

sbi PORTB,3          ;    VT2
ldi XL,$00           ;     
ldi XH,$A6
ldi YL,$0E
Main1:               ;    
cpi Comp,5	 	     ;   
breq Main0			 ;  ,   
sbis PINB,1			 ;   ,   SB1 
rjmp Main0           ;   
sbic ACSR,ACO		; U < U, ACO=1
inc CntSt
sbis ACSR,ACO		; U > U, ACO=0
dec CntSt
cpi CntSt,Imax		;       Umax
brsh Main2
cpi CntSt,Imin		;       Umin
brlo Main2
out OCR0A,CntSt		;    
rjmp Main1          ;   
Main2:
ldi CntSt,Imin
out OCR0A,CntSt
rjmp Main1
Main0:
rcall Delay          ;   
ldi XL,$00           ;     
ldi XH,$A6
ldi YL,$0E
clr Comp			 ;  
cbi PORTB,3          ;    VT2

ldi t1,(1<<WGM01)|(1<<WGM00);   T0, OC0A   
out TCCR0A,t1
ldi t1,(1<<INT0)
out GIMSK,t1		 ;   
ldi t1,1<<ACD
out ACSR,t1			 ;  
ldi  t1,(1<<SE)|(1<<SM1);  "" , Power-Down
out  MCUCR,t1
sleep                ;   Power-Down
ldi  t1,(1<<SM1)     ;  "" , Power-Down
out  MCUCR,t1
ldi t1,0
out GIMSK,t1		 ;   
ldi t1,1<<ACBG
out ACSR,t1		 	 ;      AIN0 , 1,11V
ldi  t1,0            ;    T0
out  TCNT0,t1
ldi t1,(1<<COM0A1)|(1<<WGM01)|(1<<WGM00) ;   T0," "
out TCCR0A,t1
rcall Delay          ;   
rjmp Main

Delay: ;   
subi XL,1		 
sbci XH,0
sbci YL,0
brcc Delay


TimerOFF: ;  ,    

dec Cnt0          ;  
brne TF0          ;   ,   
ldi Cnt0,Const0
dec Cnt1          ;  
brne TF0          ;   ,   
ldi Cnt1,Const1
dec Cnt2          ;  
brne TF0          ;   ,    
ldi Cnt2,Const2
dec Cnt3          ;  
brne TF0          ;   ,    
ldi Cnt0,Const0   ;    
ldi Cnt1,Const1
ldi Cnt2,Const2
ldi Cnt3,Const3
ldi Comp,5        ;     
ret
TF0:
ret

TIMER0_COMPA: ;    T0

rcall TimerOFF    ;  ,  

reti

;*********************************************************************************
.Exit

